#import <Foundation/NSObject.h>
#import <Foundation/NSString.h>
#import <Foundation/NSAutoreleasePool.h>

@interface NPEngineCore : NSObject
{
    NSString * name;
}

+ (NPEngineCore *) instance;

- (id) init;
- (id) initWithName:(NSString *)newName;
- (void) dealloc;

- (NSString *) name;

@end

static NPEngineCore * NP_ENGINE_CORE = nil;

@implementation NPEngineCore

+ (NPEngineCore *)instance
{
    @synchronized(self)
    {
        if ( NP_ENGINE_CORE == nil )
        {
            [[ self alloc ] init ];
        }
    }

    return NP_ENGINE_CORE;
} 

+ (id)allocWithZone:(NSZone *)zone
{
    @synchronized(self)
    {
        if (NP_ENGINE_CORE == nil)
        {
            NP_ENGINE_CORE = [ super allocWithZone:zone ];
            return NP_ENGINE_CORE;
        }
    }

    return nil;
}

- (id) init
{
    return [ self initWithName:@"NPEngine Core" ];
}

- (id) initWithName:(NSString *)newName
{
    self = [ super init ];

    name = [ newName retain ];

    NSLog([[NPEngineCore instance] name ]);

    return self;
}

- (void) dealloc
{
    NSLog(@"");
    NSLog(@"NP Engine Core Dealloc");

    [ super dealloc ];
}

- (NSString *) name
{
    return name;
}

@end


int main (int argc, char **argv)
{
    NSAutoreleasePool * pool = [[ NSAutoreleasePool alloc ] init ];
    NPEngineCore * core = [ NPEngineCore instance ];
    [ pool release ];
    return 0;
}
